//+------------------------------------------------------------------+
//|                                                3MAsMarket_v1.mq4 |
//|                                  Copyright  2008, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers   6
#property indicator_color1    Green
#property indicator_width1    2 
#property indicator_color2    Red
#property indicator_width2    2
#property indicator_color3    LightGreen
#property indicator_width3    2
#property indicator_color4    Orange
#property indicator_width4    2 
#property indicator_color5    Yellow
#property indicator_width5    2 

//---- input parameters
extern int       Price        =  0;
extern int       Length1      =  3; 
extern int       ModeMA1      =  3; 
extern int       Length2      =  8; 
extern int       ModeMA2      =  3;
extern int       Length3      = 14; 
extern int       ModeMA3      =  3;

//---- buffers
double Up[];
double Dn[];
double pUp[];
double pDn[];
double Choppy[];
double pChoppy[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Up);
   
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dn);
   
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,pUp);
   
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,pDn);
   
   SetIndexBuffer(4,Choppy);
   SetIndexStyle(4,DRAW_HISTOGRAM); 
    SetIndexBuffer(5,pChoppy);
   SetIndexStyle(5,DRAW_HISTOGRAM);     

   string short_name="3MAsMarket";
   IndicatorShortName(short_name);
      
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
   SetIndexLabel(2,"Possible UpTrend");
   SetIndexLabel(3,"Possible DownTrend");      
   SetIndexLabel(4,"Choppy");
//----
   SetIndexDrawBegin(0,Length3);
   SetIndexDrawBegin(1,Length3);
   SetIndexDrawBegin(2,Length3);
   SetIndexDrawBegin(3,Length3);
   SetIndexDrawBegin(4,Length3);
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int      i,counted_bars=IndicatorCounted();
   
   int limit = Bars-counted_bars+1;
   
   for(i=limit;i>=0;i--)
   {
   double MA1  = iMA(NULL,0,Length1,0,ModeMA1,Price,i);
   double MA11 = iMA(NULL,0,Length1,0,ModeMA1,Price,i+1);
   double MA2  = iMA(NULL,0,Length2,0,ModeMA2,Price,i);
   double MA3  = iMA(NULL,0,Length3,0,ModeMA3,Price,i);
    
   bool Cond1 = MA1 > MA2 && MA2 > MA3 && MA1 > MA11;
   bool Cond2 = MA1 > MA2 && MA2 < MA3 && MA1 > MA11;
   bool Cond3 = MA1 < MA2 && MA2 < MA3 && MA1 < MA11;
   bool Cond4 = MA1 < MA2 && MA2 > MA3 && MA1 < MA11;
     
   Up[i] = EMPTY_VALUE;
   Dn[i] = EMPTY_VALUE;
   pUp[i] = EMPTY_VALUE;
   pDn[i] = EMPTY_VALUE;
   Choppy[i] = EMPTY_VALUE;
   pChoppy[i] = EMPTY_VALUE;
   
      if (Cond1) {Up[i] = High[i]; Dn[i] = Low[i];}
      else
      if (Cond2) {pUp[i] = High[i]; pDn[i] = Low[i];}
      else
      if (Cond3) {Up[i] = Low[i]; Dn[i] = High[i];}
      else
      if (Cond4) {pUp[i] = Low[i]; pDn[i] = High[i];}
      else 
      {Choppy[i] = High[i]; pChoppy[i] = Low[i];}
   }
//----
   
   return(0);
}
//+------------------------------------------------------------------+

